{% extends "ajax/game/game.html.twig" %}
{% block title %}{{ forum.title|raw }}{% endblock %}
{% block menu_text %}
    {{parent()}}
    <li class="back-dash" x-ajax-href="{{ url('game_landing') }}">{{ 'Zum Spiel'|trans({},'global') }}</li>
{% endblock %}

{# @var forum \App\Entity\Forum #}
{# @var permission \App\Structures\ForumPermissionAccessor #}

{% macro display_thread_list( list, fid, icon, title, select, jump, permission, add_seperators = false ) %}
    <div class="forum-note">
        <b><i class="fa {{ icon }}"></i> {{ title }}</b>
        {% set last_day = 'today'|to_date %}
        {% for thread in list %}
            {% set postUrl = path('forum_viewer_controller', {fid: fid, tid: thread.id }) %}
            {% if thread.id == select and jump > 0 %}
                {% set postUrlFg = path('forum_viewer_controller', {fid: fid, tid: thread.id, pid: jump }) %}
            {% else %}
                {% set postUrlFg = postUrl %}
            {% endif %}

            {% if add_seperators and thread.lastPost and last_day != thread.lastPost.date|date_modify('today') %}
                {% set last_day = thread.lastPost.date|date_modify('today') %}
                <div class="row forum-separator"><div class="cell rw-12 padded-small">
                    {% if last_day >= 'today'|to_date %}{{ 'Heute'|trans({},'global') }}
                    {% elseif last_day >= 'yesterday'|to_date %}{{ 'Gestern'|trans({},'global') }}
                    {% elseif last_day >= 'tomorrow-1week'|to_date %}{{last_day|format_datetime(pattern="EEEE")}}
                    {% else %}{{last_day|format_datetime('full', 'none')}}{% endif %}
                </div></div>
            {% endif %}

            <div class="row forum-thread {% if thread.new %}forum-thread-unread{% endif%}" x-public-route="{{ path('forum_thread_view', {fid: fid, tid: thread.id }) }}" {% if postUrl != postUrlFg %}x-post-source-next="{{ postUrlFg }}"{% endif%} x-post-source="{{ postUrl }}" x-thread-id="{{ thread.id }}">
                {# @var thread \App\Entity\Thread #}
                <div class="cell rw-1 status" style="padding: 5px;">
                    {% if thread.locked %}
                        <img alt="" src="{{ asset('build/images/icons/lock.gif') }}" />
                    {% else %}
                        &nbsp;
                    {% endif %}
                </div>
                <div class="cell rw-8 title"  style="padding: 5px;">
                    <div {% if thread.hidden %}style="color: red"{% endif %}>
                        {% if thread.translatable %}
                            {{ thread.title|trans({},'game') }}
                        {% else %}
                            {{ thread.title }}
                        {% endif %}
                        {% if permission.moderate and thread.reportedPosts %}
                            <span class="float-right">
                                <img alt="" src="{{ asset('build/images/forum/warning.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Mindestens ein Post in diesem Thema wurde den Moderatoren gemeldet.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% endif %}
                        {% if thread.hasAdminAnnounce %}
                            <span class="float-right">
                                <img alt="" src="{{ asset('build/images/forum/adminAnnounce.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Dieses Thema enthält offizielle Ansagen der Website Administratoren.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% elseif thread.hasOracleAnnounce %}
                            <span class="float-right">
                                <img src="{{ asset('build/images/forum/announce.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Dieses Thema enthält Ansagen von Community-Vertretern.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% endif %}
                    </div>
                </div>
                <div class="cell rw-3 right count" style="background:#593223; padding: 5px;">
                    <div class='nbPost'>
                    {% if thread.visiblePosts|length > 1 %}
                        {{ thread.visiblePosts|length - 1 }}
                    {% else %}
                        &nbsp;
                    {% endif %}
                    </div>
                    <div class="author">
                    {% set last_post = thread.lastPost %}
                    {% if last_post and last_post.owner %}
                        {% if last_post.owner.name == 'Der Rabe' %}
                            {{ 'Der Rabe'|trans({},'global') }}
                        {% else %}
                            {{ last_post.owner.name }}
                        {% endif %}
                    {% elseif thread.owner %}
                        {% if thread.owner.name == 'Der Rabe' %}
                            {{ 'Der Rabe'|trans({},'global') }}
                        {% else %}
                            {{ thread.owner.name }}
                        {% endif %}
                    {% else %}
                        {{ 'Der Rabe'|trans({},'global') }}
                    {% endif %}
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
{% endmacro %}

{% block ajax %}
    <div class="row">
        <div class="cell rw-12">
            <div class="row">
                <div class="cell padded rw-5 rw-md-12">
                    <div class="forum-control">
                        <div class="forum-header-bar">
                            <a href="#" x-ajax-href="{{ url('forum_list') }}">{{ 'Alle Foren'|trans({},'global') }}</a>
                            <span><i class="fa fa-caret-right"></i></span>
                            <b><i class="fa fa-scroll"></i> {{ forum.title }}</b>
                        </div>
                        <div class="forum-button-bar">
                            <div x-ajax-href="{{ url('forum_list') }}" class="forum-button"><img alt="" src="{{ asset('build/images/forum/back.png') }}" /><div class="tooltip forum-tooltip">{{ 'Zurück'|trans({},'global') }}</div></div>
                            <div x-ajax-href="{{ url('forum_view', {id: forum.id}) }}" class="forum-button"><img alt="" src="{{ asset('build/images/forum/refresh.png') }}" /><div class="tooltip forum-tooltip">{{ 'Liste der Themen aktualisieren'|trans({},'global') }}</div></div>
                            {% if not permission.only_mod_access %}
                                <div x-forum-action="search" class="forum-button"><img alt="" src="{{ asset('build/images/forum/search.png') }}" /><div class="tooltip forum-tooltip">{{ 'Nachrichten suchen'|trans({},'global') }}</div></div>
                            {% endif %}
                            {% if is_granted("ROLE_FORUM_BANNED") or not permission.create_thread() %}
                                <div class="forum-button-disabled" id="banned">{{ 'Neues Thema'|trans({},'global') }}</div>
                            {% else %}
                                <div x-forum-action="new" class="forum-button" id="new-thread-button"><span>{{ 'Neues Thema'|trans({},'global') }}</span></div>
                            {% endif %}    
                        </div>
                    </div>
                    <br />
                    {% if forum.description is not empty %}
                        <div class="forum-control">
                            <div class="quote">
                                <i class="fa fa-quote-left"></i><span>{{ forum.description }}</span><i class="fa fa-quote-right"></i>
                            </div>
                        </div>
                        <br />
                    {% endif %}

                    {% if permission.only_mod_access %}
                        <div class="forum-control">
                            <b><i class="fa fa-exclamation"></i> {{ 'Moderation'|trans({},'global') }}</b>
                            <div class="pad">{{ 'Du moderierst dieses Forum, verfügst aber nicht über Leserechte. Es werden dir nur Threads angezeigt, in denen mindestens ein Post gemeldet wurde.' }}</div>
                        </div>
                        <br />
                    {% endif %}

                    {% if pinned_threads %}
                        {{ _self.display_thread_list(pinned_threads, forum.id, 'fa-thumbtack', 'Sticky'|trans({}, 'global'), select, jump, permission) }}
                        <br />
                    {% endif %}

                    {{ _self.display_thread_list(threads, forum.id, 'fa-scroll', forum.title, select, jump, permission, true) }}
                    {% if pages > 1 %}
                        <div class="row">
                            <div class="cell rw-12 padded center">
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="1"><i class="fa fa-fast-backward"></i></div>
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ current_page - 1 }}"><i class="fa fa-backward"></i></div>
                                <div class="forum-button">{{ 'Seite %page%/%pages%'|trans({'%page%': current_page, '%pages%': pages},'global') }}</div>
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ current_page + 1 }}"><i class="fa fa-forward"></i></div>
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ pages }}"><i class="fa fa-fast-forward"></i></div>
                            </div>
                        </div>
                    {% endif %}
                </div>

                <div class="cell padded rw-7 rw-md-12">
                    <div id="forum-content">
                        <div class="forum-note">
                            <b>{{ 'Bitte halte dich an die Regeln:'|trans({},'global') }}</b>
                            <ul>
                                <li>{{ 'Achte auf deine Rechtschreibung'|trans({},'global') }}</li>
                                <li>{{ 'Bleibe höflich und freundlich'|trans({},'global') }}</li>
                                <li>{{ 'Werbung ist verboten (Links etc.)'|trans({},'global') }}</li>
                            </ul>
                        </div>
                    </div>
                    <div id="forum-forum-editor"></div>
                    <div id="forum-editor-anchor"></div>

                </div>
            </div>

        </div>
    </div>
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>

        function get_forum_editor() {
            let editor = document.getElementById('forum-forum-editor');
            if (!editor) {
                editor = document.createElement('div');
                editor.setAttribute('id', 'forum-editor');
                let anchor = document.getElementById('forum-editor-anchor');
                anchor.parentNode.insertBefore(editor, anchor);
            }
            return editor;
        }

        {% if not is_granted("ROLE_FORUM_BANNED") and permission.create_thread() %}
            $.html.addEventListenerAll('[x-forum-action=new]', 'click', function() {
                $.html.forEach('[x-thread-id]', element => element.classList.remove('selected'))
                let viewer = document.getElementById('forum-content');
                {let c; while ((c = viewer.firstChild)) viewer.removeChild(c);}
                $.ajax.no_history().load( get_forum_editor(), '{{ url('forum_thread_editor_controller', {id: forum.id}) }}', false )
            });
        {% endif %}

        {% if not permission.only_mod_access %}
            $.html.addEventListenerAll('[x-forum-action=search]', 'click', function() {
                $.html.forEach('[x-thread-id]', element => element.classList.remove('selected'))
                let viewer = document.getElementById('forum-content');
                {let c; while ((c = viewer.firstChild)) viewer.removeChild(c);}
                $.ajax.no_history().load( viewer, '{{ url('forum_id_search_controller', {fid: forum.id}) }}', false )
            });
        {% endif %}

        $.html.addEventListenerAll('[x-thread-id]', 'click', function (e,elem) {
            $.html.forEach('[x-thread-id]', element => element.classList.remove('selected'))
            elem.classList.add('selected');
            let editor = get_forum_editor();
            { let c; while ((c = editor.firstChild)) editor.removeChild(c); }

            let load_url = elem.getAttribute('x-post-source');
            if (elem.getAttribute('x-post-source-next')) {
                load_url = elem.getAttribute('x-post-source-next');
                elem.setAttribute('x-post-source-next','');
            }

            $.ajax.no_history().load(document.getElementById('forum-content'), load_url, false, {}, get_forum_editor)
            $.ajax.push_history(elem.getAttribute('x-public-route'));
        });

        $.html.addEventListenerAll('[x-thread-id]', 'mousedown', function (e,elem) {
            if (e.button === 1) {
                e.preventDefault();
                window.open(elem.getAttribute('x-public-route'), '_blank');
            }
        });

        let selection_target = document.querySelector('[x-thread-id="{{ select }}"]');
        if (selection_target) selection_target.click();

        $.html.addEventListenerAll( '[x-forum-action="thread-pager"][x-to-page]', 'click',
            (e,elem) => $.ajax.no_history().load( null, '{{ path('forum_view', {id: forum.id}) }}', false, {page: parseInt( elem.getAttribute('x-to-page') )} ) );
    </script>
{% endblock %}